• hdu 1548 (dijkstra解法)(一次AC就是爽)


    A strange lift

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 11670    Accepted Submission(s): 4430


    Problem Description
    There is a strange lift.The lift can stop can at every floor as you want, and there is a number Ki(0 <= Ki <= N) on every floor.The lift have just two buttons: up and down.When you at floor i,if you press the button "UP" , you will go up Ki floor,i.e,you will go to the i+Ki th floor,as the same, if you press the button "DOWN" , you will go down Ki floor,i.e,you will go to the i-Ki th floor. Of course, the lift can't go up high than N,and can't go down lower than 1. For example, there is a buliding with 5 floors, and k1 = 3, k2 = 3,k3 = 1,k4 = 2, k5 = 5.Begining from the 1 st floor,you can press the button "UP", and you'll go up to the 4 th floor,and if you press the button "DOWN", the lift can't do it, because it can't go down to the -2 th floor,as you know ,the -2 th floor isn't exist.
    Here comes the problem: when you are on floor A,and you want to go to floor B,how many times at least he has to press the button "UP" or "DOWN"?
     

    Input
    The input consists of several test cases.,Each test case contains two lines.
    The first line contains three integers N ,A,B( 1 <= N,A,B <= 200) which describe above,The second line consist N integers k1,k2,....kn.
    A single 0 indicate the end of the input.
     

    Output
    For each case of the input output a interger, the least times you have to press the button when you on floor A,and you want to go to floor B.If you can't reach floor B,printf "-1".
     

    Sample Input
    5 1 5 3 3 1 2 5 0
     

    Sample Output
    3
     

    Recommend
    8600   |   We have carefully selected several similar problems for you:  1385 1242 1142 1217 2066 
     

    这道题刚拿到的时候,我就觉得和最短路径没关系。不过,在后来的思考中我慢慢发现了它与最短路径间的
    联系。这道题要求解的是最少的按键次数并要求能够到达目的楼层,而且每个楼层只能向上或向下移动该楼层
    规定的层数,那么从a楼层到规定楼层只需按一次键即可。这里,我们可以将这一过程模拟成最短路径中等的
    从a地道另一个指定位置的过程,而两地的距离即权值就是1,那么上下楼层的问题可以看成是从一个地方
    到另一个地方,而两地的间距都是1的移动过程。最后,在通过dijkstra算法来统计出从起点到终点所需的
    按键次数即可,若可到达就输出次数,不可到达的话次数为无穷大,输出-1。

    AC代码:

    #include<stdio.h>
    #include<string.h>
    #define max 0x3f3f3f3f
    int map[201][201];
    int dist[201];
    int floor[201];
    void dijkstra(int num,int v)
    {
     bool vis[201];
     memset(vis,0,sizeof(vis));
     int i,j;
     for(i=1;i<=num;i++)
     {
      dist[i]=map[v][i];
     }
     dist[v]=0;
     vis[v]=1;
     for(i=2;i<=num;i++)
     {
      int tmp=max;
      int u=v;
      for(j=1;j<=num;j++)
       if((!vis[j])&&dist[j]<tmp)
       {
        u=j;
        tmp=dist[j];
       }
      vis[u]=1;
      for(j=1;j<=num;j++)
       if((!vis[j])&&map[u][j]<max)
       {
        int newdist=dist[u]+map[u][j];
        if(newdist<dist[j])
        {
         dist[j]=newdist;
        }
       }
     }

    }
    int main()
    {
     int n;
     while(scanf("%d",&n)!=EOF&&n)
     {
      memset(map,max,sizeof(map));
      int start,end;
      scanf("%d%d",&start,&end);
      int i;
      for(i=1;i<=n;i++)
      {
       scanf("%d",&floor[i]);
       if(floor[i]+i<=n)
        map[i][floor[i]+i]=1;
       if(i-floor[i]>=1)
        map[i][i-floor[i]]=1;
      }
      dijkstra(n,start);
      if(dist[end]==max)
       printf("-1 ");
      else
       printf("%d ",dist[end]);
     }
     return 0;
    }

  • 相关阅读:
    工欲性能调优,必先利其器(2)- 火焰图
    工欲性能调优,必先利其器(1)
    关于烂代码的那些事(上)
    HTTP 返回码中 301 与 302 的区别
    HTTP 状态码 301 和 302 详解及区别——辛酸的探索之路
    HTTP 状态码之:301、302 重定向
    记一次获得 3 倍性能的 go 程序优化实践,及 on-cpu / off-cpu 火焰图的使用
    Coloring Flame Graphs: Code Hues
    StackOverflow 创始人关于如何高效编程的清单
    Spring Bean的生命周期(非常详细)
  • 原文地址:https://www.cnblogs.com/hbutACMER/p/3913403.html
Copyright © 2020-2023  润新知